module m_type

type phys
 real :: L,H            ! length and height of the domain (m)
 real :: U0             ! characteristic parameter for the velocity (s^-1)
 real :: D              ! diffusivity (m^2/s)
 real :: C0,C1          ! initial concentrations in the domain 
 real :: R1             ! initial radius of polution (of concentration C1)
 real :: Cl,Cr,Ct,Cb    ! concentration at the left,right,top,bottom
 real :: tf             ! final time (s)
end type phys

type num
 integer :: nx, ny      ! number of cells in x- and y-direction
 integer :: Nout        ! number of intermediate unsaved time steps 
 real    :: CFL         ! Courant's number (advection)
 real    :: R           ! Fourier's number (diffusion)
end type num

end module m_type

