subroutine read_data(p,n)

  ! Utilisation du module
  use m_type

  implicit none
  ! DECLACARTIONS
  ! Variables en arguments
  type(phys), intent(out) :: p
  type(num),  intent(out) :: n

  ! INSTRUCTIONS
  open(10,file="data_2D.txt")
  read(10,*)
  read(10,*)
  read(10,*) p%L,p%H
  read(10,*) p%U0
  read(10,*) p%D
  read(10,*) p%C0,p%C1
  read(10,*) p%R1
  read(10,*) p%Cl,p%Cr,p%Ct,p%Cb
  read(10,*) p%tf
  read(10,*)
  read(10,*)
  read(10,*)
  read(10,*) n%nx,n%ny
  read(10,*) n%Nout
  read(10,*) n%CFL
  read(10,*) n%R
  close(10)

end subroutine read_data

!-------------------------------
subroutine mesh(p,n,x_reg,y_reg)

  ! Utilisation du module
  use m_type

  implicit none

  ! DECLARATIONS
  ! Variables en arguments
  type(phys), intent(in) :: p
  type(num),  intent(in) :: n
  real, dimension(n%nx), intent(out) :: x_reg
  real, dimension(n%ny), intent(out) :: y_reg
  ! Variables locales
  integer :: i,j

  ! INSTRUCTIONS
  do i=1,n%nx
    x_reg(i) =  p%L / real(n%nx-1) * real(i-1)
  end do
  do j=1,n%ny
    y_reg(j) =  p%H / real(n%ny-1) * real(j-1)
  end do

end subroutine mesh

!-------------------
function dist(p,x,y)

  ! Utilisation du module
  use m_type

  implicit none

  ! DECLARATIONS
  ! Variables en arguments
  type(phys), intent(in) :: p
  real, intent(in) :: x,y
  ! Fonction
  real :: dist

  ! INSTRUCTIONS
  dist = sqrt((x-p%L/2.)**2+(y-p%H/2.)**2)

end function dist

!-----------------------------------
subroutine C_init(p,n,x_reg,y_reg,C)

  ! Utilisation du module
  use m_type

  implicit none

  ! DECLARATIONS
  ! Variables en arguments
  type(phys), intent(in) :: p
  type(num),  intent(in) :: n
  real, dimension(n%nx),      intent(in)    :: x_reg
  real, dimension(n%ny),      intent(in)    :: y_reg
  real, dimension(n%nx,n%ny), intent(out) :: C
  ! Variables locales
  real :: dist
  real :: d1,delta
  integer :: i,j

  ! INSTRUCTIONS
  do i=1,n%nx
    do j=1,n%ny
      d1     = dist(p,x_reg(i),y_reg(j))
      delta  = min(p%L/real(n%nx-1),p%H/real(n%ny-1))/1.5
      C(i,j) = p%C1 + (p%C0-p%C1)*(1.+erf((d1-p%R1)/delta))/2.
    end do
  end do

end subroutine C_init


